/*
 
 Copyright (C) 2010,2011 Timo Lassmann <timolassmann@gmail.com>
 
 This file is part of delve.
 
 Delve is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 Delve is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Delve.  If not, see <http://www.gnu.org/licenses/>.
 
 */

#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <ctype.h>

#define MAX_LINE 1000
#define BUFFER_SIZE 1000000


struct db_seq_info{
	unsigned char** names;
	unsigned int* len;
	float* nuc_counts;
	int* sn_len;
	int num_seq;
	unsigned int total_len;
};

struct db{
	struct db_seq_info* seq_info;
	char* dbname;
	unsigned int* bfa; 
};


struct db* init_db(struct db* db,struct parameters* param);
struct db* main_read_db(struct db* db,struct parameters* param);
void main_write_db(struct db* db,struct parameters* param);
void db_write_seqio(struct db*  db,struct parameters* param);
struct db* db_read_seqio(struct db*  db,struct parameters* param);
struct db* read_bfa(struct db*  db,struct parameters* param);

struct db* add_seq_info(struct db* db, char* fasta);
unsigned int get_chr_offset(struct db_seq_info * si, char* chr);
unsigned char* get_chr_name(struct db_seq_info* si, unsigned int pos);
unsigned int  get_chr_pos(struct db_seq_info* si, unsigned int pos);

unsigned int get_sequence(struct db* db,unsigned char* seq,unsigned int start,unsigned int len,int strand);

unsigned char* reverse_complement2(unsigned char* p,int len);
unsigned char* reverse_without_complement(unsigned char* p,int len);

void free_db(struct db* db);



