/*
 
 Copyright (C) 2010,2011 Timo Lassmann <timolassmann@gmail.com>
 
 This file is part of delve.
 
 Delve is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 Delve is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Delve.  If not, see <http://www.gnu.org/licenses/>.
 
 */

#define MAX_LINE 1000
#define FILE_END 0xFFFFFFFFFFFFFFFFu

#include <pthread.h>

struct seq_info{
	//unsigned long int fB[4];
	//unsigned long int rB[4];
	unsigned long int* match_units;
	unsigned char* sn;
	unsigned char* seq;
	unsigned char* reverse_seq;
	unsigned char* qual;
	unsigned int id_num;
	int len;
	long int last_f_test;
	long int last_r_test;
	
	
};

struct qs_struct{
	struct seq_info** seq_info;
	unsigned char* string;
	
	int* hash;
	int* hash_index;
	
	int** hash_t;
	int** hash_index_t;
	
	int string_len;
	int q_num;
	int size;
	int min_len;
	int max_len;
};

struct seed_thread_data{
	struct qs_struct* qs;
	struct parameters* param;
	long int len;
	long int total_len;
	unsigned char* chromsome;
	int start;
	int end;
	int thread;
};


int seed_controller(struct parameters* param);

struct qs_struct* init_query_structure(struct qs_struct * qs,struct parameters* param);
void free_query_structure(struct qs_struct * qs,struct parameters* param);

struct qs_struct* search_fasta_fastq(struct qs_struct* qs,struct parameters* param);
unsigned long int read_fasta_fastq(FILE *file, struct qs_struct* qs,struct parameters* param,unsigned long int position);
void reverse_complement(unsigned char* p,unsigned char* rc,int len);

struct qs_struct* make_hash(struct qs_struct* qs,int r);
struct qs_struct* search_hash(struct qs_struct* qs,unsigned char* t,int n, long int r,long int offset);
void print_sam(struct seq_info* si, unsigned char** t_names, long int* lengths,int size);

int seed_controller_thread(struct parameters* param);
struct qs_struct* search_fasta_fastq_thread(struct qs_struct* qs,struct parameters* param);
struct qs_struct* make_hash_thread(struct qs_struct* qs,int r,int step,int thread,int start,int stop);
void* search_hash_thread(void *threadarg);

struct qs_struct* make_B(struct qs_struct* qs,int n);
struct qs_struct* read_fasta_fastq2(FILE *file, struct qs_struct* qs,struct parameters* param) ;
unsigned int rev_bits(unsigned int x);

